#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int a[MAXN + 1];
string comb[MAXN + 1][MAXN + 1];
int n, m;

string sum(string a, string b)
{
    if (a.size() < b.size()) swap(a, b);
    int j = b.size() - 1;
    int carry = 0;

    for (int i = a.size() - 1; i >= 0; i--)
    {
        int sum = a[i] - '0' + carry;
        if (j >= 0) sum += b[j--] - '0';
        a[i] = char(sum % 10 + '0');
        carry = sum / 10;
    }

    if (carry) a = "1" + a;
    return a;
}

int countFlowers(int L, int R)
{
    int cnt = 0;

    for (int i = 1; i <= n; i++)
        if (a[i] >= L && a[i] <= R)
            cnt++;

    return cnt;
}

bool isGreaterOrEqual(string a, string b)
{
    if (a.size() == b.size()) return a >= b;
    return a.size() > b.size();
}

int solve(int L, int R, string K)
{
    int cnt = countFlowers(L, R);
    if (cnt == 0) return -1;

    for (int i = 1; i <= cnt; i++)
        if (isGreaterOrEqual(comb[cnt][i], K))
            return i;

    return -1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    comb[1][0] = comb[1][1] = "1";
    for (int i = 2; i <= n; i++)
        for (int j = 0; j <= i; j++)
            comb[i][j] = sum(comb[i - 1][j - 1], comb[i - 1][j]);

    for (int i = 1; i <= m; i++)
    {
        int L, R;
        string K;
        cin >> L >> R >> K;

        cout << solve(L, R, K) << endl;
    }

    return 0;
}
