#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 3000;
const int MAXM = 100000;
const int MAXA = 100000;

int a[MAXN + 1];
int countFlowers[MAXA + 1];
string comb[MAXN + 1];
int n, m;

string sum(string a, string b)
{
    if (a.size() < b.size()) swap(a, b);
    int j = b.size() - 1;
    int carry = 0;

    for (int i = a.size() - 1; i >= 0; i--)
    {
        int sum = a[i] - '0' + carry;
        if (j >= 0) sum += b[j--] - '0';
        a[i] = char(sum % 10 + '0');
        carry = sum / 10;
    }

    if (carry) a = "1" + a;
    return a;
}

bool isGreaterOrEqual(string a, string b)
{
    if (a.size() == b.size()) return a >= b;
    return a.size() > b.size();
}

int solve(int cnt, string K)
{
    if (cnt == 0) return -1;

    for (int i = 1; i <= cnt; i++)
        if (isGreaterOrEqual(comb[i], K))
            return i;

    return -1;
}

struct Query
{
    int num, cnt;
    string K;
    Query () {}
    Query (int _num, int _cnt, string _K)
    {
        num = _num;
        cnt = _cnt;
        K = _K;
    }
};

bool cmp(Query a, Query b)
{
    return a.cnt < b.cnt;
}

Query queries[MAXM + 1];
int answers[MAXM + 1];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        countFlowers[a[i]]++;
    }

    for (int i = 1; i <= MAXA; i++)
        countFlowers[i] += countFlowers[i-1];

    for (int i = 1; i <= m; i++)
    {
        int L, R;
        string K;
        cin >> L >> R >> K;

        int cnt = countFlowers[R] - countFlowers[L - 1];
        queries[i] = Query(i, cnt, K);
    }

    sort(queries + 1, queries + m + 1, cmp);

    int ind = 1;

    for (int i = 0; i <= n; i++)
    {
        comb[0] = "1";
        for (int j = i; j > 0; j--)
            comb[j] = sum(comb[j - 1], comb[j]);

        while (ind <= m && queries[ind].cnt == i)
        {
            answers[queries[ind].num] = solve(i, queries[ind].K);
            ind++;
        }

        if (ind > m) break;
    }

    for (int i = 1; i <= m; i++)
        cout << answers[i] << endl;

    return 0;
}
