#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 3000;
const int MAXM = 100000;
const int MAXA = 100000;
const int DIGITS = 18;
const long long BASE = 1e18;

typedef vector<long long> BigNumber;

int a[MAXN + 1];
int countFlowers[MAXA + 1];
BigNumber comb[MAXN + 1];
int n, m;

BigNumber sum(BigNumber &a, BigNumber &b)
{
    BigNumber result;
    long long carry = 0;
    int sizeA = a.size(), sizeB = b.size(), sizeMax = max(sizeA, sizeB);

    for (int i = 0; i < sizeMax || carry; i++)
    {
        long long sum = carry;
        if (i < sizeA) sum += a[i];
        if (i < sizeB) sum += b[i];
        result.push_back(sum % BASE);
        carry = sum / BASE;
    }

    return result;
}

bool isGreaterOrEqual(BigNumber &a, BigNumber &b)
{
    if (a.size() != b.size()) return a.size() > b.size();

    for (int i = a.size() - 1; i >= 0; i--)
        if (a[i] != b[i]) return a[i] > b[i];

    return true;
}

BigNumber stringToBigNumber(string &s)
{
    BigNumber result;
    result.reserve(s.size() / DIGITS + 1);

    for (int i = s.size(); i > 0; i -= DIGITS)
    {
        long long tmp = 0;
        for (int j = max(0, i - DIGITS); j < i; j++)
            tmp = tmp * 10 + s[j] - '0';
        result.push_back(tmp);
    }

    return result;
}

int solve(int cnt, string K)
{
    if (cnt == 0) return -1;

    BigNumber bigK = stringToBigNumber(K);

    int left = 1, right = cnt / 2 + 1;
    int result = -1;

    while (left <= right)
    {
        int mid = (left + right) / 2;
        if (isGreaterOrEqual(comb[mid], bigK))
        {
            result = mid;
            right = mid - 1;
        }
        else
        {
            left = mid + 1;
        }
    }

    return result;
}

int answers[MAXM + 1];
vector <pair<int,string>> queries[MAXN + 1];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        countFlowers[a[i]]++;
    }

    for (int i = 1; i <= MAXA; i++)
        countFlowers[i] += countFlowers[i-1];

    for (int i = 1; i <= m; i++)
    {
        int L, R;
        string K;
        cin >> L >> R >> K;

        int cnt = countFlowers[R] - countFlowers[L - 1];
        queries[cnt].push_back({i, K});
    }

    for (int i = 0; i <= n; i++)
    {
        comb[0] = {1};
        for (int j = min(i, n/2); j > 0; j--)
            comb[j] = sum(comb[j - 1], comb[j]);

        for (int j = 0; j < queries[i].size(); j++)
        {
            auto [num, K] = queries[i][j];
            answers[num] = solve(i, K);
        }
    }

    for (int i = 1; i <= m; i++)
        cout << answers[i] << endl;

    return 0;
}
